︠3c21216c-02f6-4477-9a1b-323df7c9a9eai︠
%html
<h1>The Congruent Number Problem</h1>
<ul>
<li>A <a href="http://www.aimath.org/news/congruentnumbers/" target="_blank">relevant webpage</a> [aimath.org]</li>
</ul>

<h2>Connection with Elliptic Curves (proof by computer)</h2>

<h1 style="text-align: center;"><span style="color: #827802;">Explicit Bijection</span></h1>
<p>In fact, there is a bijection between</p>
<p>$$<br />&nbsp;A = \left\{(a,b,c) \in \mathbf{Q}^3 \,:\, \frac{ab}{2} = n,\, a^2 + b^2 = c^2\right\}<br />$$<br />and <br />$$<br />&nbsp;B = \left\{(x,y) \in \mathbf{Q}^2 \,:\, y^2 = x^3 - n^2 x, \,\,\text{with } y \neq 0\right\}<br />$$<br />given by the maps<br />$$<br />&nbsp; f(a,b,c) = \left(-\frac{nb}{a+c},\,\, \frac{2n^2}{a+c}\right)<br />$$<br />and <br />$$<br />&nbsp; g(x,y) = \left(\frac{n^2-x^2}{y},\,\,-\frac{2xn}{y},\,\, \frac{n^2+x^2}{y}\right).<br />$$</p>

<p>Define bijection between rational right triangles with area $n$ and points on the elliptic curve $y^2=x^3-n^2x$ with $y\neq 0$.</p>

︡d6f3a697-693d-4b0d-981b-f293485b701e︡{"html": "<h1>The Congruent Number Problem</h1>\n<ul>\n<li>A <a href=\"http://www.aimath.org/news/congruentnumbers/\" target=\"_blank\">relevant webpage</a> [aimath.org]</li>\n</ul>\n\n<h2>Connection with Elliptic Curves (proof by computer)</h2>\n\n<h1 style=\"text-align: center;\"><span style=\"color: #827802;\">Explicit Bijection</span></h1>\n<p>In fact, there is a bijection between</p>\n<p>$$<br />&nbsp;A = \\left\\{(a,b,c) \\in \\mathbf{Q}^3 \\,:\\, \\frac{ab}{2} = n,\\, a^2 + b^2 = c^2\\right\\}<br />$$<br />and <br />$$<br />&nbsp;B = \\left\\{(x,y) \\in \\mathbf{Q}^2 \\,:\\, y^2 = x^3 - n^2 x, \\,\\,\\text{with } y \\neq 0\\right\\}<br />$$<br />given by the maps<br />$$<br />&nbsp; f(a,b,c) = \\left(-\\frac{nb}{a+c},\\,\\, \\frac{2n^2}{a+c}\\right)<br />$$<br />and <br />$$<br />&nbsp; g(x,y) = \\left(\\frac{n^2-x^2}{y},\\,\\,-\\frac{2xn}{y},\\,\\, \\frac{n^2+x^2}{y}\\right).<br />$$</p>\n\n<p>Define bijection between rational right triangles with area $n$ and points on the elliptic curve $y^2=x^3-n^2x$ with $y\\neq 0$.</p>"}︡
︠f1276551-a974-42b0-8cb0-d9c67ae56c12︠
def f(a,b,c, n):
    return (-n*b/(a+c), 2*n^2/(a+c))
def g(x,y, n):
    return ((n^2-x^2)/y, -2*x*n/y, (n^2+x^2)/y)
︡120b2dfa-0e18-4087-b31c-4787ae2f152b︡︡
︠78c3f1ec-6993-4cf1-bd67-9738f99e1501i︠
%html
<p>Use computer to verify that this is a bijection.</p>

︡1faaeef8-d4a2-4449-8ba9-9a2c2f93b5de︡{"html": "<p>Use computer to verify that this is a bijection.</p>"}︡
︠a6eab457-84b3-41f0-87dc-49186bec2f95︠
R.<a,b,c,n> = QQ[]
x,y = f(a,b,c, n)
g(x,y, n)
︡3017d670-92a6-4cd5-b9e8-573b7c653eee︡{"stdout": "((a^2 - b^2 + 2*a*c + c^2)/(2*a + 2*c), b, (a^2 + b^2 + 2*a*c + c^2)/(2*a + 2*c))"}︡
︠66e474dd-492f-4c32-9847-8c8df97e9b65i︠
%html
<p>By working in the quotient polynomial ring and<strong></strong> avoiding fractions we get that the composition $g \circ f$ is the identity map.</p>

︡f2e4c6e7-53d3-4d4d-8732-0701a5598815︡{"html": "<p>By working in the quotient polynomial ring and<strong></strong> avoiding fractions we get that the composition $g \\circ f$ is the identity map.</p>"}︡
︠2e967454-6285-4138-b02d-e857c90df8c1︠
Q = R.quotient([a^2 + b^2 - c^2, a*b-2*n])
v1 = g(x,y, n)
v2 = (a,b,c)
for i in range(3):  
    print Q(v1[i].numerator() - v2[i].numerator()*v1[i].denominator())
︡63d490d8-a5a5-4631-8c14-bdb6491fff11︡{"stdout": "0\n0\n0"}︡
︠432ab342-d9d7-424b-b60d-f95704c2ff29︠
R.<x,y,n> = QQ[]
a, b, c = g(x,y,n)
︡111588b8-56c3-40b7-9171-2a4b99346b09︡︡
︠1cbb9c35-426f-4bd1-b692-b34b2656b734︠
Q = R.quotient([y^2 - (x^3-n^2*x)])
v1 = f(a,b,c, n)
v2 = (x,y)
for i in range(2):  
    print Q(v1[i].numerator() - v2[i].numerator()*v1[i].denominator())
︡858b99e5-5f06-4de0-807e-b8dfa7504d3e︡{"stdout": "0\n0"}︡
︠9186075c-3e74-41ee-a38e-9a5b272e47b1i︠
%html
<p>So we know that the claimed bijections are valid.</p>

︡884eaf5e-cdba-41b5-9796-0b2d24dd3fe8︡{"html": "<p>So we know that the claimed bijections are valid.</p>"}︡
︠8d3da049-2715-4af7-a3b3-f6ab876b0885︠
def cong(n):
    G = EllipticCurve([-n^2,0]).gens()
    if len(G) == 0: return False
    x,y,_ = G[0]
    return ((n^2-x^2)/y,-2*x*n/y,(n^2+x^2)/y)
︡c4d8f2cf-a4e7-40de-9226-82936c4ce988︡︡
︠4954e621-8665-4e3a-9f13-a685954f9ef2︠
for n in [1..15]:
    print n, cong(n)
︡97658664-66b3-4476-ad71-42b2e6e9e96f︡{"stdout": "1 False\n2 False\n3 False\n4 False\n5 (3/2, 20/3, 41/6)\n6 (3, 4, 5)\n7 (-24/5, -35/12, 337/60)\n8 False\n9 False\n10 False\n11 False\n12 False\n13 (323/30, 780/323, 106921/9690)\n14 (-8/3, -21/2, 65/6)\n15 (4, 15/2, 17/2)"}︡
︠37ceeea1-4391-4258-a42f-79a6848c35d9︠
@interact
def _(n=6, triangles=(1..10), maxtime=(3..30)):
    x,y = var('x,y')
    C = EllipticCurve(y^2 == x^3 - n^2*x)
    try:
        alarm(maxtime)
        t = walltime()
        G = C.gens()
        print "time = %.2f seconds"%walltime(t)
    except RuntimeError:
        print "Sage is unable to provably find generators"
        return
    except KeyboardInterrupt, msg:
        print "Too hard -- timed out after %s seconds"%maxtime
        return
    html("rank = %s\n\n"%len(G))
    if len(G) == 0: print "%s is not a congruent number"%n; return
    def g(x,y,n): return ((n^2-x^2)/y, -2*x*n/y, (n^2+x^2)/y)
    P = G[0]
    html('<h3><font color="red">Rational Right Triangles with Area %s</font></h3>'%n)
    for i in [1..triangles]:
        a,b,c = g((i*P)[0], (i*P)[1], n)
        html("(a,b,c) = $%s$\n"%latex((a,b,c)))
︡42e9dfed-5c50-46f8-98ca-667470b22a09︡︡
︠4021fc85-645a-431e-bb09-44885a539196i︠
%html
<hr />
<h2>Tunnell's Criterion:</h2>

︡663360be-58a0-4748-8d36-0a7eff28ea1c︡{"html": "<hr />\n<h2>Tunnell's Criterion:</h2>"}︡
︠b7f20804-3dd6-4b98-bacb-443dfa9d9745︠
def cong_number_sets(n):
    """
    Given a positive integer n, returns the two sets appearing in the
    conjectural criterion for when a number is congruent.
    """
    n = ZZ(n)
    n = ZZ(prod([p for p, e in n.factor() if e%2 == 1]))
    
    if n % 2 == 0:   # even case
        E = []       # with c even
        O = []       # with c odd
        a_bound = floor(sqrt(n/8) + 1)
        c_bound = floor(sqrt(n)/4 + 1)
        half_n = n//2
        for c in range(-c_bound, c_bound+1):
            c_square = c^2
            for a in range(-a_bound, a_bound+1):
                a_square = a^2
                z = half_n - 4*a_square - 8*c_square
                try:
                    b = z.sqrt(extend=False)
                    if b.denominator() == 1:
                        b = b.numerator()
                        assert 4*a^2 + b^2 + 8*c^2 == n/2
                        if c % 2 == 0:
                            E.append((a,b,c))
                        else:
                            O.append((a,b,c))
                except ValueError:
                    pass
    else:
        E = []       # with c even
        O = []       # with c odd
        a_bound = floor(sqrt(n/2)+1)
        c_bound = floor(sqrt(n/8) + 1)
        for c in range(-c_bound, c_bound+1):
            c_square = c^2
            for a in range(-a_bound, a_bound+1):
                a_square = a^2
                z = n - 2*a_square - 8*c_square
                try:
                    b = z.sqrt(extend=False)
                    if b.denominator() == 1:
                        b = b.numerator()
                        assert 2*a^2 + b^2 + 8*c^2 == n
                        if c % 2 == 0:
                            E.append((a,b,c))
                        else:
                            O.append((a,b,c))
                except ValueError:
                    pass
    return E, O

def is_conj_cong_number(n):
    """
    Returns True if n is conjecturally a congruent number, according
    to the Birch and Swinnerton-Dyer conjecture.
    """
    E, O = cong_number_sets(n)
    return len(E) == len(O)
︡08746756-90c9-467e-8fc8-e1bfcda79072︡︡
︠a62e20f9-4ed0-43f8-b79f-5a3de129fbe4i︠
%html
<p>First congruent number $\equiv 3 \pmod{8}$</p>

︡23d56a96-30b2-4981-a43d-f91284cfef05︡{"html": "<p>First congruent number $\\equiv 3 \\pmod{8}$</p>"}︡
︠777280e9-f129-454f-af97-003b0515a247︠
time is_conj_cong_number(219)
︡c940a909-4b6e-43b2-a298-612f5d08895b︡{"stdout": "True\nTime: CPU 0.02 s, Wall: 0.03 s"}︡
︠be826f5f-1a44-429f-9d64-b97317d3a237︠
219 % 8
︡1342c539-9dcd-41c5-b5be-c1170ea318f4︡{"stdout": "3"}︡
︠5c84cab5-7670-42ab-a99b-ddea9099405d︠
cong(219)
︡009de427-97e9-4603-9507-6846d5455db0︡{"stdout": "(55/4, 1752/55, 7633/220)"}︡
︠84586876-6a60-4c06-8578-902a7782a462i︠
%html
<p>This year isn't congruent:</p>

︡104f8e47-9413-4cab-94e9-1bf4bd05183d︡{"html": "<p>This year isn't congruent:</p>"}︡
︠12d077ca-fb53-4bed-a388-6c43f5e8ec02︠
time is_conj_cong_number(2010)
︡57a3da21-e034-4376-8a14-0a4165891249︡{"stdout": "False\nTime: CPU 0.02 s, Wall: 0.02 s"}︡
︠dcb4f484-36f3-4d3e-800d-32c490980575︠
cong(2010)
︡f5e8f48e-941c-4c11-9eb9-47320fafc771︡{"stdout": "False"}︡
︠ae83a5c0-7bd4-4a91-9d5b-1d04f407f100︠
time is_conj_cong_number(2011)
︡f42cead9-32e6-4657-ae31-34f13c8f43ea︡{"stdout": "False\nTime: CPU 0.02 s, Wall: 0.04 s"}︡
︠6b34a3c6-0f6a-4b1c-b505-d606d72a5df8︠
time is_conj_cong_number(2012)
︡10116451-f1dc-476c-99b4-f9164c522386︡{"stdout": "True\nTime: CPU 0.02 s, Wall: 0.02 s"}︡
︠6cb66c85-7fbb-4b12-ae27-28a262db603a︠
cong(2012)
︡79bd5200-9181-448d-b4dd-292a8370a9dd︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"_sage_input_63.py\", line 9, in <module>\n    exec compile(ur'open(\"___code___.py\",\"w\").write(\"# -*- coding: utf-8 -*-\\n\" + _support_.preparse_worksheet_cell(base64.b64decode(\"Y29uZygyMDEyKQ==\"),globals())+\"\\n\"); execfile(os.path.abspath(\"___code___.py\"))' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/tmp/tmptRTSZC/___code___.py\", line 3, in <module>\n    exec compile(ur'cong(_sage_const_2012 )' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/tmp/tmpKsNmc0/___code___.py\", line 4, in cong\n    G = EllipticCurve([-n**_sage_const_2 ,_sage_const_0 ]).gens()\n  File \"/home/wstein/sage/local/lib/python2.6/site-packages/sage/schemes/elliptic_curves/ell_rational_field.py\", line 1931, in gens\n    \"\\nTry increasing descent_second_limit then trying this command again.\"\nRuntimeError: Unable to compute the rank, hence generators, with certainty (lower bound=0, generators found=[]).  This could be because Sha(E/Q)[2] is nontrivial.\nTry increasing descent_second_limit then trying this command again."}︡
︠829bb8b2-5e5e-4d92-af8a-9301ec81410c︠
E = EllipticCurve([-2012^2,0])
︡20c69e2c-fdd6-46c7-b96c-069bd0c94590︡︡
︠4cb4e823-412a-4cd2-9a3c-611fe4d003e5︠
E.analytic_rank()
︡d170d24f-cb55-4a26-9b14-54a523564f8b︡{"stdout": "1"}︡
